# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CustomResourcetypesBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'display_name': 'str',
        'description': 'str',
        'resource_type': 'str',
        'external_type': 'str',
        'status': 'str',
        'org_id': 'str',
        'project_id': 'str',
        'main_actions': 'FormserviceapicustomresourcetypesMainActions',
        'additional_actions': 'list[FormserviceapicustomresourcetypesAdditionalActions]',
        'properties': 'FormserviceapicustomresourcetypesProperties',
        'schema_type': 'str',
        'properties_yaml': 'str'
    }

    attribute_map = {
        'id': 'id',
        'display_name': 'displayName',
        'description': 'description',
        'resource_type': 'resourceType',
        'external_type': 'externalType',
        'status': 'status',
        'org_id': 'orgId',
        'project_id': 'projectId',
        'main_actions': 'mainActions',
        'additional_actions': 'additionalActions',
        'properties': 'properties',
        'schema_type': 'schemaType',
        'properties_yaml': 'propertiesYaml'
    }

    def __init__(self, id=None, display_name=None, description=None, resource_type=None, external_type=None, status=None, org_id=None, project_id=None, main_actions=None, additional_actions=None, properties=None, schema_type=None, properties_yaml=None):  # noqa: E501
        """CustomResourcetypesBody - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._display_name = None
        self._description = None
        self._resource_type = None
        self._external_type = None
        self._status = None
        self._org_id = None
        self._project_id = None
        self._main_actions = None
        self._additional_actions = None
        self._properties = None
        self._schema_type = None
        self._properties_yaml = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if resource_type is not None:
            self.resource_type = resource_type
        if external_type is not None:
            self.external_type = external_type
        if status is not None:
            self.status = status
        if org_id is not None:
            self.org_id = org_id
        if project_id is not None:
            self.project_id = project_id
        if main_actions is not None:
            self.main_actions = main_actions
        if additional_actions is not None:
            self.additional_actions = additional_actions
        if properties is not None:
            self.properties = properties
        if schema_type is not None:
            self.schema_type = schema_type
        if properties_yaml is not None:
            self.properties_yaml = properties_yaml

    @property
    def id(self):
        """Gets the id of this CustomResourcetypesBody.  # noqa: E501


        :return: The id of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CustomResourcetypesBody.


        :param id: The id of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this CustomResourcetypesBody.  # noqa: E501


        :return: The display_name of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this CustomResourcetypesBody.


        :param display_name: The display_name of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this CustomResourcetypesBody.  # noqa: E501


        :return: The description of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CustomResourcetypesBody.


        :param description: The description of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def resource_type(self):
        """Gets the resource_type of this CustomResourcetypesBody.  # noqa: E501


        :return: The resource_type of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this CustomResourcetypesBody.


        :param resource_type: The resource_type of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    @property
    def external_type(self):
        """Gets the external_type of this CustomResourcetypesBody.  # noqa: E501


        :return: The external_type of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._external_type

    @external_type.setter
    def external_type(self, external_type):
        """Sets the external_type of this CustomResourcetypesBody.


        :param external_type: The external_type of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._external_type = external_type

    @property
    def status(self):
        """Gets the status of this CustomResourcetypesBody.  # noqa: E501


        :return: The status of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CustomResourcetypesBody.


        :param status: The status of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["RELEASED", "DRAFT"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def org_id(self):
        """Gets the org_id of this CustomResourcetypesBody.  # noqa: E501


        :return: The org_id of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this CustomResourcetypesBody.


        :param org_id: The org_id of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def project_id(self):
        """Gets the project_id of this CustomResourcetypesBody.  # noqa: E501


        :return: The project_id of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this CustomResourcetypesBody.


        :param project_id: The project_id of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def main_actions(self):
        """Gets the main_actions of this CustomResourcetypesBody.  # noqa: E501


        :return: The main_actions of this CustomResourcetypesBody.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesMainActions
        """
        return self._main_actions

    @main_actions.setter
    def main_actions(self, main_actions):
        """Sets the main_actions of this CustomResourcetypesBody.


        :param main_actions: The main_actions of this CustomResourcetypesBody.  # noqa: E501
        :type: FormserviceapicustomresourcetypesMainActions
        """

        self._main_actions = main_actions

    @property
    def additional_actions(self):
        """Gets the additional_actions of this CustomResourcetypesBody.  # noqa: E501


        :return: The additional_actions of this CustomResourcetypesBody.  # noqa: E501
        :rtype: list[FormserviceapicustomresourcetypesAdditionalActions]
        """
        return self._additional_actions

    @additional_actions.setter
    def additional_actions(self, additional_actions):
        """Sets the additional_actions of this CustomResourcetypesBody.


        :param additional_actions: The additional_actions of this CustomResourcetypesBody.  # noqa: E501
        :type: list[FormserviceapicustomresourcetypesAdditionalActions]
        """

        self._additional_actions = additional_actions

    @property
    def properties(self):
        """Gets the properties of this CustomResourcetypesBody.  # noqa: E501


        :return: The properties of this CustomResourcetypesBody.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesProperties
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this CustomResourcetypesBody.


        :param properties: The properties of this CustomResourcetypesBody.  # noqa: E501
        :type: FormserviceapicustomresourcetypesProperties
        """

        self._properties = properties

    @property
    def schema_type(self):
        """Gets the schema_type of this CustomResourcetypesBody.  # noqa: E501


        :return: The schema_type of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._schema_type

    @schema_type.setter
    def schema_type(self, schema_type):
        """Sets the schema_type of this CustomResourcetypesBody.


        :param schema_type: The schema_type of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._schema_type = schema_type

    @property
    def properties_yaml(self):
        """Gets the properties_yaml of this CustomResourcetypesBody.  # noqa: E501


        :return: The properties_yaml of this CustomResourcetypesBody.  # noqa: E501
        :rtype: str
        """
        return self._properties_yaml

    @properties_yaml.setter
    def properties_yaml(self, properties_yaml):
        """Sets the properties_yaml of this CustomResourcetypesBody.


        :param properties_yaml: The properties_yaml of this CustomResourcetypesBody.  # noqa: E501
        :type: str
        """

        self._properties_yaml = properties_yaml

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomResourcetypesBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomResourcetypesBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
